package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class ExampleDefaultEnumPersistence {

    private static EntityManagerFactory emf = Persistence.createEntityManagerFactory("test1");

    public static void main(String[] args) {
        showGeneratedTables();
        persistEntities();
        loadEntities();
    }

    private static void showGeneratedTables() {
        EntityManager em = emf.createEntityManager();
        Util.nativeQuery(em, "SHOW TABLES");
        Util.nativeQuery(em, "SHOW COLUMNS from MyEntity");
        em.close();
    }

    private static void persistEntities() {
        MyEntity entity = new MyEntity(1, MyEnum.ConstC);
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        em.persist(entity);
        em.getTransaction().commit();
        em.close();
        System.out.println("MyEntity persisted: " + entity);
    }

    private static void loadEntities() {
        EntityManager em = emf.createEntityManager();
        Util.nativeQuery(em, "select * from MyEntity");
        MyEntity myEntity = em.find(MyEntity.class, 1L);
        System.out.printf("Entity loaded by entity manager: %s%n", myEntity);
        em.close();
    }
}